<?php

function ldap_verify_0001($redirect, $authorized)
{	
	/*
	Damon Vaughn Caskey
	ldap_verify_0001
	2011_11_10
	Verify user is logged into session with AD account, and is part of authorized group. 
	
	$redirect:		Should a log in be required, this will appear on log in screen after successful sign in. 
	$authorized:	List of authorized users. If provided, user's AD account will be verified against list. If NULL, any valid user may access the page.
	*/
		
	$LDAP_cn;											//AD account name from session.
	$val;												//Value extracted from array loop.
	$header = "Location:  /authenticate_0001.php";		//URL of authentication page.	
	
	session_start();									//Start or continue session.
		
	$AD_cn = $_SESSION['LDAP_cn'];						//Get account name from session.
	
	/* Default for redirect dialog. */
	if(!isset($redirect))
	{		
		$redirect = "Please click <a href=".$_SERVER['PHP_SELF'].">here</a> to proceed.";
	}
		
	if(!isset($AD_cn))									//Account blank?
	{	
		/* No one is session. Send user to the authenticate page and prepare message to pass after a successful log in. */		
		$_SESSION['redirect_dialog'] = $redirect;		//Set redirect dialog.
		header($header);								//Send user to authenticate page.
		return FALSE;									//Return False.
	}
	else
	{			
		/* If a list of authorized accounts is provided, verify current user is included. */
		if(isset($authorized))							//List array passed?
		{
			foreach($authorized as $val)				//Loop array collection.
			{
				if($val == $AD_cn)						//Element a match vs. user account?
				{					
					return TRUE;						//Return True.
				}
			}
		}
		else											//No list. Page is open to anyone with valid account.
		{
			return TRUE;								//Return True.
		}		
		
		/* If we got this far, user is valid but not authorized. Create a dialog and send user back to authenticate page */
		$_SESSION['authenticate_dialog'] = "We're sorry ".$_SESSION['LDAP_first_name'].", but you are not permitted to access this resource. Please log in with an authorized account." ;
		header($header);
		return FALSE;
	}
}
?>